#!/usr/bin/env python
#-*- coding:utf-8 -*-

import re
import os
import sys
import math
import time
import struct
import random

from libnum import *

MAGIC = "\xde\xad\xfa\xce" + "\xa9" * 8 + "\xf1\xf2\xf3\xf4"

N = 308437044275067938131653453561001047357000826062737759785845990336
C = 111111111111111111111111111111111111111111111111111111111111112000
E = 31337

factors = [(2,6),(3,3),(761364314999,1),(891083343019,1),(263094610336089343590963140117371337377,1)]

vals = []
mods = []
for p, n in factors:
    mods.append(p**n)
    if n == 1:
        vals.append(prime_sqrtmod(a, p)[0])
    else:
        for x in xrange(p**n):
            if (x**2) % (p**n) == a % (p**n):
                vals.append(x)
                break
        else:
            print "No root for ", a, "%", p**n
            quit()

M = solve_crt(vals, mods)

def keygen(card):
    if card['type'] != "Mifare 4K":
        return deny("Bad card type")

    serial = card.read(0, 0)
    print "GOT CARD:", serial.encode("hex")
    serial = s2n(serial)

    K = pow(serial, E, N)
    X = (M - K) % N
    
    print "CHECK: pow(key + pow(serial, E, N), 2, N)"
    print pow(key + pow(serial, E, N), 2, N)
    print "CHECK: C"
    print C

    x1 = X & ((1 << 128) - 1)
    x2 = X >> 128

    card.write(0, 1, MAGIC)
    card.write(1, 0, n2s(x2).rjust(16, "\x00"))
    card.write(1, 1, n2s(x1).rjust(16, "\x00"))
    return

import rfid
rfid.server(keygen)
